<template>
  <el-row>
    <el-col :span="24">
      <el-table @row-click="goToRouteInfo" :data="GETTERS_ROUTES || []">
        <el-table-column
          prop="cityA"
          label="From city"
        ></el-table-column>
        <el-table-column
          prop="cityB"
          label="To city"
        ></el-table-column>
        <el-table-column prop="distance" label="Distance, km"></el-table-column>

        <el-table-column
          prop="expected_revenue"
          label="Expected revenue, $"
        ></el-table-column>

        <el-table-column prop="registration_mark" label="Car"></el-table-column>

        <el-table-column fixed="right" label="Operations" width="160">
          <template slot-scope="scope">
            <el-button
              size="mini"
              @click.stop="$router.push({ path: '/editroute/' + scope.row.id })"
              >Edit</el-button
            >
            <el-button
              size="mini"
              type="danger"
              @click.stop="handleDeleteRoute(scope.row)"
              >Delete</el-button
            >
          </template>
        </el-table-column>
      </el-table>
    </el-col>
    <el-col :span="24">
      <el-pagination
        background
        @size-change="ACTIONS_ROUTES_PAGE_SIZE_CHANGE"
        :total="GETTERS_ROUTES_TOTAL_COUNT"
        layout="sizes,prev,pager,next"
      >
      (я не работаю)
      </el-pagination>
      
    </el-col>
  </el-row>
</template>

<script>
  import { mapGetters, mapActions } from "vuex";
  import {
    GETTERS_ROUTES,
    GETTERS_ROUTES_TOTAL_COUNT,
    ACTIONS_GET_ROUTES,
    ACTIONS_DELETE_ROUTE,
    ACTIONS_ROUTES_PAGE_SIZE_CHANGE,
  } from "@/plugins/constants";

  export default {
    methods: {
      handleDeleteRoute(row) {
        if (!row || !row.hasOwnProperty("id")) return;

        this.ACTIONS_DELETE_ROUTE(row.id)
          .then((_) =>
            this.$notify.success({ message: "Route successfully deleted" })
          )
          .catch(({ response }) => this.$notify.error({ message: response.data }))
          .finally(() => this.ACTIONS_GET_ROUTES());
      },
      ...mapActions({
        ACTIONS_DELETE_ROUTE,
        ACTIONS_GET_ROUTES,
        ACTIONS_ROUTES_PAGE_SIZE_CHANGE,
      }),
      goToRouteInfo(row) {
        if (row && row.id)
          this.$router.push({ name: "Route", params: { id: row.id } });
      },
    },
    computed: {
      ...mapGetters({
        GETTERS_ROUTES,
        GETTERS_ROUTES_TOTAL_COUNT,
      }),
    },
    mounted() {
      this.ACTIONS_GET_ROUTES().catch((error) =>
        this.$notify.error({ message: "Something went wrong" })
      );
    },
  };
</script>

<style>
  tr {
    cursor: pointer;
  }
</style>